using Blazored.LocalStorage;
using FNZCM.BlazorWasm;
using FNZCM.BlazorWasm.Helpers;
using FNZCM.BlazorWasm.UI;
using Microsoft.AspNetCore.Components;
using Microsoft.AspNetCore.Components.Web;
using Microsoft.AspNetCore.Components.WebAssembly.Hosting;
using System.Buffers;

var builder = WebAssemblyHostBuilder.CreateDefault(args);
builder.Services.AddBlazoredLocalStorage();


builder.Services.AddScoped(sp =>
{
    var http = new HttpClient();

#if DEBUG
    http.BaseAddress = new Uri("http://fnz-server");
#else
    var NavManager = sp.GetService<NavigationManager>();
    var ba = new Uri($"{NavManager.ToAbsoluteUri("/").GetLeftPart(UriPartial.Scheme | UriPartial.Authority)}");
    http.BaseAddress = ba;
#endif   

    return http;
});

builder.Services.AddScoped<ApiClient>();
builder.Services.AddScoped<FnzDataSet>();
builder.Services.AddScoped<LocalStorageHelper>();

builder.RootComponents.Add<App>("#app");
builder.RootComponents.Add<HeadOutlet>("head::after");

await builder.Build().RunAsync();
