﻿using FNZCM.BlazorWasm.Helpers;

namespace FNZCM.BlazorWasm.UI
{
    public partial class App
    {
        private bool IsLoading = true;
        private string LoadingErrorMessage;

        protected override async Task OnInitializedAsync()
        {
            base.OnInitialized();

            StateHasChanged();
            await Task.Delay(10);

            await LoadData();
        }

        private async Task LoadData()
        {
            IsLoading = true;
            await ProgressBar.SetProgress(0, "Waiting server ready");
            try
            {
                do
                {
                    var r = await ApiClient.GetProgressAsync();
                    await ProgressBar.SetProgress((float)r.LoadedTags / r.TotalTrackCount, $"Waiting server ready {r.LoadedTags}/{r.TotalTrackCount}");
                    if (r?.IsLoading == false) break;
                    await Task.Delay(1000);
                } while (true);

                StateHasChanged();
                await Task.Delay(10);

                await DataSet.InitFeModulesAsync(ProgressBar);

                StateHasChanged();
                await Task.Delay(500);

                IsLoading = false;
            }
            catch (Exception ex)
            {
                LoadingErrorMessage = ex.Message;
            }
        }
    }
}
