﻿using Newtonsoft.Json;

namespace FNZCM.BlazorWasm.UI.Components.Fnz.Modal
{
    public enum Backdrops
    {
        On,
        Off,
        Static
    }

    public class BackdropsJsonConverter : JsonConverter
    {
        public override bool CanConvert(Type objectType) 
            => objectType == typeof(Backdrops);

        public override object ReadJson(JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer) 
            => throw new NotImplementedException();

        public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer)
        {
            var v = (Backdrops)value;
            writer.WriteValue(v switch
            {
                Backdrops.On => true,
                Backdrops.Off => false,
                Backdrops.Static => "static",
                _ => null,
            });
        }
    }
}
